#include <bits/stdc++.h>
using namespace std;
using ll = long long;
vector<pair<ll, int> > t1;
vector<pair<ll, ll> > t2;
vector<ll> push;
int n;

void merge(int v) {
    t2[v].first = t2[v * 2 + 1].first + t2[v * 2].first;
    t2[v].second = t2[v * 2].second + t2[v * 2 + 1].second;
}

void build(int v, int l, int r, vector<ll> &a) {
    if (l + 1 == r) {
        t1[v] = {a[l], l};
        t2[v] = {0, a[l]};
        return;
    }
    int m = (l + r) / 2;
    build(v * 2, l, m, a);
    build(v * 2 + 1, m, r, a);
    t1[v] = max(t1[v * 2], t1[v * 2 + 1]);
    merge(v);
}

int get1(int v, int l, int r, int ql, int qr, ll x) {
    if (qr <= l || r <= ql) {
        return -1;
    }
    if (ql <= l && r <= qr) {
        if (t1[v].first < x) {
            return -1;
        }
        while (v * 2 < int(t1.size()) && t1[v * 2].first != -1) {
            if (t1[v * 2 + 1].first >= x) {
                v = v * 2 + 1;
            } else {
                v = v * 2;
            }
        }
        return t1[v].second;
    }
    int m = (l + r) / 2;
    int v1 = get1(v * 2, l, m, ql, qr, x);
    int v2 = get1(v * 2 + 1, m, r, ql, qr, x);
    return max(v1, v2);
}

int get2(int v, int l, int r, int ql, int qr, ll x) {
    if (qr <= l || r <= ql) {
        return n;
    }
    if (ql <= l && r <= qr) {
        if (t1[v].first < x) {
            return n;
        }
        while (v * 2 < int(t1.size()) && t1[v * 2].first != -1) {
            if (t1[v * 2].first >= x) {
                v = v * 2;
            } else {
                v = v * 2 + 1;
            }
        }
        return t1[v].second;
    }
    int m = (l + r) / 2;
    int v1 = get2(v * 2, l, m, ql, qr, x);
    int v2 = get2(v * 2 + 1, m, r, ql, qr, x);
    return min(v1, v2);
}

void makepush(ll v, ll l, ll r) {
    if (push[v] == -1) {
        return;
    }
    ll m = (l + r) / 2;
    push[v * 2] = push[v];
    push[v * 2 + 1] = push[v];
    t2[v * 2].first = (push[v] * (m - l)) - t2[v * 2].second;
    t2[v * 2 + 1].first = (push[v] * (r - m)) - t2[v * 2 + 1].second;
    push[v] = -1;
}

void update(int v, int l, int r, int ql, int qr, ll x) {
    if (qr <= l || r <= ql) {
        return;
    }
    if (ql <= l && r <= qr) {
        push[v] = x;
        t2[v].first = (push[v] * (r - l)) - t2[v].second;
        return;
    }
    int m = (l + r) / 2;
    makepush(v, l, r);
    update(v * 2, l, m, ql, qr, x);
    update(v * 2 + 1, m, r, ql, qr, x);
    merge(v);
}

ll get(int v, int l, int r, int ql, int qr) {
    if (qr <= l || r <= ql) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        return t2[v].first;
    }
    int m = (l + r) / 2;
    makepush(v, l, r);
    ll v1 = get(v * 2, l, m, ql, qr);
    ll v2 = get(v * 2 + 1, m, r, ql, qr);
    return v1 + v2;
}

pair<ll, int> get_max(int v, int l, int r, int ql, int qr) {
    if (qr <= l || r <= ql) {
        return {-1, -1};
    }
    if (ql <= l && r <= qr) {
        return t1[v];
    }
    int m = (l + r) / 2;
    auto v1 = get_max(v * 2, l, m, ql, qr);
    auto v2 = get_max(v * 2 + 1, m, r, ql, qr);
    return max(v1, v2);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<ll> h(n);
    set<pair<int, int> > seg;
    for (int i = 0; i < n; i++) {
        cin >> h[i];
        seg.insert({i, i});
    }
    vector<int> q(n - 1);
    for (int i = 0; i < n - 1; i++) {
        cin >> q[i];
    }
    for (int i = 0; i < n - 1; i++) {
        int l1 = 0, r1 = 0, l2 = 0, r2 = 0;
        int cnt = 0;
        for (auto [l, r]: seg) {
            cnt++;
            if (cnt == q[i]) {
                l1 = l, r1 = r;
            } else if (cnt == q[i] + 1) {
                l2 = l, r2 = r;
                break;
            }
        }
        seg.erase({l1, r1});
        seg.erase({l2, r2});
        seg.insert({l1, r2});
        int id1 = l1, id2 = l2;
        for (int j = l1; j <= r1; j++) {
            if (h[j] >= h[id1]) {
                id1 = j;
            }
        }
        for (int j = l2; j <= r2; j++) {
            if (h[j] > h[id2]) {
                id2 = j;
            }
        }
        ll ans = 0;
        if (h[id1] <= h[id2]) {
            multiset<ll> all = {};
            multiset<ll> all1;
            for (int j = l1; j <= r1; j++) {
                all.insert(h[j]);
            }
            for (int j = l1; j <= r1; j++) {
                all1.insert(h[j]);
                if (j >= id1) {
                    ans += (h[id1] - h[j]);
                } else {
                    auto it1 = *all1.rbegin();
                    auto it2 = *all.rbegin();
                    ans += min(it1, it2) - h[j];
                }
                all.erase(all.find(h[j]));
            }
            int from = -1;
            for (int j = l2; j <= r2; j++) {
                if (h[j] >= h[id1]) {
                    from = j;
                    break;
                }
            }
            all.clear();
            all1.clear();
            for (int j = l2; j <= r2; j++) {
                all.insert(h[j]);
            }
            for (int j = l2; j <= from - 1; j++) {
                ans += (h[id1] - h[j]);
            }
            for (int j = l2; j <= r2; j++) {
                all1.insert(h[j]);
                if (j >= from) {
                    auto it1 = *all1.rbegin();
                    auto it2 = *all.rbegin();
                    ans += min(it1, it2) - h[j];
                }
                all.erase(all.find(h[j]));
            }
        } else {
            multiset<ll> all;
            multiset<ll> all1 = {};
            for (int j = l2; j <= r2; j++) {
                all.insert(h[j]);
            }
            for (int j = l2; j <= r2; j++) {
                all1.insert(h[j]);
                if (j <= id2) {
                    ans += (h[id2] - h[j]);
                } else {
                    auto it1 = *all1.rbegin();
                    auto it2 = *all.rbegin();
                    ans += min(it1, it2) - h[j];
                }
                all.erase(all.find(h[j]));
            }
            int from = -1;
            for (int j = r1; j >= l1; j--) {
                if (h[j] >= h[id2]) {
                    from = j;
                    break;
                }
            }
            all.clear();
            all1.clear();
            for (int j = l1; j <= r1; j++) {
                all.insert(h[j]);
            }
            for (int j = r1; j >= from + 1; j--) {
                ans += (h[id2] - h[j]);
            }
            for (int j = l1; j <= r1; j++) {
                all1.insert(h[j]);
                if (j <= from) {
                    auto it1 = *all1.rbegin();
                    auto it2 = *all.rbegin();
                    ans += min(it1, it2) - h[j];
                }
                all.erase(all.find(h[j]));
            }
        }
        cout << ans << "\n";
    }
    return 0;
}
