#include <bits/stdc++.h>
using namespace std;
using ll = long long;
vector<pair<ll, int> > t1;
vector<pair<ll, ll> > t2;

struct node {
    int l, r, val, id;
};

vector<node> t;
vector<ll> push;
int n;

void upd(int v, int l, int r, int id, int lq, int rq, int val) {
    if (l + 1 == r) {
        t[v].val += val;
        t[v].l = lq;
        t[v].r = rq;
        t[v].id = l;
        return;
    }
    int m = (l + r) / 2;
    if (id < m) {
        upd(v * 2, l, m, id, lq, rq, val);
    } else {
        upd(v * 2 + 1, m, r, id, lq, rq, val);
    }
    t[v].val = t[v * 2].val + t[v * 2 + 1].val;
}

int sum(int v, int l, int r, int ql, int qr) {
    if (qr <= l || r <= ql) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        return t[v].val;
    }
    int m = (l + r) / 2;
    int v1 = sum(v * 2, l, m, ql, qr);
    int v2 = sum(v * 2 + 1, m, r, ql, qr);
    return v1 + v2;
}

pair<int, int> getp(int v, int l, int r, int id) {
    if (l + 1 == r) {
        return {t[v].l, t[v].r};
    }
    int m = (l + r) / 2;
    if (id < m) {
        return getp(v * 2, l, m, id);
    } else {
        return getp(v * 2 + 1, m, r, id);
    }
}

void merge(int v) {
    t2[v].first = t2[v * 2 + 1].first + t2[v * 2].first;
    t2[v].second = t2[v * 2].second + t2[v * 2 + 1].second;
}

void build(int v, int l, int r, vector<ll> &a) {
    if (l + 1 == r) {
        t1[v] = {a[l], l};
        t2[v] = {0, a[l]};
        return;
    }
    int m = (l + r) / 2;
    build(v * 2, l, m, a);
    build(v * 2 + 1, m, r, a);
    t1[v] = max(t1[v * 2], t1[v * 2 + 1]);
    merge(v);
}

int get1(int v, int l, int r, int ql, int qr, ll x) {
    if (qr <= l || r <= ql) {
        return -1;
    }
    if (ql <= l && r <= qr) {
        if (t1[v].first < x) {
            return -1;
        }
        while (v * 2 < int(t1.size()) && t1[v * 2].first != -1) {
            if (t1[v * 2 + 1].first >= x) {
                v = v * 2 + 1;
            } else {
                v = v * 2;
            }
        }
        return t1[v].second;
    }
    int m = (l + r) / 2;
    int v1 = get1(v * 2, l, m, ql, qr, x);
    int v2 = get1(v * 2 + 1, m, r, ql, qr, x);
    return max(v1, v2);
}

int get2(int v, int l, int r, int ql, int qr, ll x) {
    if (qr <= l || r <= ql) {
        return n;
    }
    if (ql <= l && r <= qr) {
        if (t1[v].first < x) {
            return n;
        }
        while (v * 2 < int(t1.size()) && t1[v * 2].first != -1) {
            if (t1[v * 2].first >= x) {
                v = v * 2;
            } else {
                v = v * 2 + 1;
            }
        }
        return t1[v].second;
    }
    int m = (l + r) / 2;
    int v1 = get2(v * 2, l, m, ql, qr, x);
    int v2 = get2(v * 2 + 1, m, r, ql, qr, x);
    return min(v1, v2);
}

void makepush(ll v, ll l, ll r) {
    if (push[v] == -1) {
        return;
    }
    ll m = (l + r) / 2;
    push[v * 2] = push[v];
    push[v * 2 + 1] = push[v];
    t2[v * 2].first = (push[v] * (m - l)) - t2[v * 2].second;
    t2[v * 2 + 1].first = (push[v] * (r - m)) - t2[v * 2 + 1].second;
    push[v] = -1;
}

void update(int v, int l, int r, int ql, int qr, ll x) {
    if (qr <= l || r <= ql) {
        return;
    }
    if (ql <= l && r <= qr) {
        push[v] = x;
        t2[v].first = (push[v] * (r - l)) - t2[v].second;
        return;
    }
    int m = (l + r) / 2;
    makepush(v, l, r);
    update(v * 2, l, m, ql, qr, x);
    update(v * 2 + 1, m, r, ql, qr, x);
    merge(v);
}

ll get(int v, int l, int r, int ql, int qr) {
    if (qr <= l || r <= ql) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        return t2[v].first;
    }
    int m = (l + r) / 2;
    makepush(v, l, r);
    ll v1 = get(v * 2, l, m, ql, qr);
    ll v2 = get(v * 2 + 1, m, r, ql, qr);
    return v1 + v2;
}

auto comp1(pair<ll, int> p1, pair<ll, int> p2) {
    if (p1.first > p2.first) {
        return p1;
    } else if (p1.first < p2.first) {
        return p2;
    } else {
        if (p1.second > p2.second) {
            return p1;
        }
        return p2;
    }
}

auto comp2(pair<ll, int> p1, pair<ll, int> p2) {
    if (p1.first > p2.first) {
        return p1;
    } else if (p1.first < p2.first) {
        return p2;
    } else {
        if (p1.second < p2.second) {
            return p1;
        }
        return p2;
    }
}

pair<ll, int> get_max1(int v, int l, int r, int ql, int qr) {
    if (qr <= l || r <= ql) {
        return {-1, -1};
    }
    if (ql <= l && r <= qr) {
        return t1[v];
    }
    int m = (l + r) / 2;
    auto v1 = get_max1(v * 2, l, m, ql, qr);
    auto v2 = get_max1(v * 2 + 1, m, r, ql, qr);
    return comp1(v1, v2);
}

pair<ll, int> get_max2(int v, int l, int r, int ql, int qr) {
    if (qr <= l || r <= ql) {
        return {-1, -1};
    }
    if (ql <= l && r <= qr) {
        return t1[v];
    }
    int m = (l + r) / 2;
    auto v1 = get_max2(v * 2, l, m, ql, qr);
    auto v2 = get_max2(v * 2 + 1, m, r, ql, qr);
    return comp2(v1, v2);
}

int main() {
    cin >> n;
    vector<ll> h(n);
    t.assign(4 * n, {-1, -1, 0, -1});
    for (int i = 0; i < n; i++) {
        cin >> h[i];
        upd(1, 0, n, i, i, i, 1);
    }
    t1.assign(4 * n, {-1, -1});
    t2.assign(4 * n, {0, 0});
    push.assign(4 * n, -1);
    vector<int> q(n - 1);
    for (int i = 0; i < n - 1; i++) {
        cin >> q[i];
    }
    build(1, 0, n, h);
    map<ll, map<ll, int> > used;
    for (int i = 0; i < n - 1; i++) {
        int l1 = 0, r1 = 0, l2 = 0, r2 = 0;
        int l = -1;
        int r = n - 1;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            int val = sum(1, 0, n, 0, mid + 1);
            if (val >= q[i]) {
                r = mid;
            } else {
                l = mid;
            }
        }
        l1 = getp(1, 0, n, r).first, r1 = getp(1, 0, n, r).second;
        int to = r;
        l = -1;
        r = n - 1;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            int val = sum(1, 0, n, 0, mid + 1);
            if (val >= q[i] + 1) {
                r = mid;
            } else {
                l = mid;
            }
        }
        l2 = getp(1, 0, n, r).first, r2 = getp(1, 0, n, r).second;
        upd(1, 0, n, r, -1, -1, -1);
        upd(1, 0, n, to, -1, -1, -1);
        upd(1, 0, n, r, l1, r2, 1);
        int id1 = get_max1(1, 0, n, l1, r1 + 1).second;
        int id2 = get_max2(1, 0, n, l2, r2 + 1).second;
        ll ans = 0;
        if (h[id1] <= h[id2]) {
            if (used.find(l1) == used.end() || used[l1].find(r1) == used[l1].end()) {
                update(1, 0, n, id1, r1 + 1, h[id1]);
                used[l1][r1] = 1;
            }
            ans += get(1, 0, n, l1, r1 + 1);
            int from = get2(1, 0, n, l2, r2 + 1, h[id1]);
            update(1, 0, n, l2, from, h[id1]);
            ans += get(1, 0, n, l2, from);
            ans += get(1, 0, n, from, r2 + 1);
        } else {
            if (used.find(l2) == used.end() || used[l2].find(r2) == used[l2].end()) {
                update(1, 0, n, l2, id2 + 1, h[id2]);
                used[l1][r1] = 1;
            }
            ans += get(1, 0, n, l2, r2 + 1);
            int from = get1(1, 0, n, l1, r1 + 1, h[id2]);
            update(1, 0, n, from + 1, r1 + 1, h[id2]);
            ans += get(1, 0, n, from + 1, r1 + 1);
            ans += get(1, 0, n, l1, from + 1);
        }
        cout << ans << "\n";
    }
    return 0;
}
